#include <stdio.h>
#include <windows.h>
#include <string.h>

/*
Todo :
XML Formatting
Delete Directory
Delete File
Get/Set File Attributes
Save / Save As File Name
*/

/*

<node name="" category="" type="" color="" size="" xPosition="" yPosition="" zPosition=""/>

*/
//-----------------------------------------------------------------------------
FILE* npmswFileDialog (const char* fileName, int dialogType, void* dataRef)
{	
	
	switch (dialogType)
	{
		case kNPfileDialogNew : ; break;

		case kNPfileDialogOpen : ; break;
		case kNPfileDialogClose : ; break;

		case kNPfileDialogSave : ; break;
		case kNPfileDialogSaveAs : ; break;

		case kNPfileDialogImport : ; break;
		case kNPfileDialogExport : ; break;

		default : break;
	}

	return NULL;
}

HANDLE openFileDialog(HANDLE hd)
{
	OPENFILENAME tmpOfn;
	HANDLE hwnd = NULL;
	char fileBuff[260];	// buffer for file name

	ZeroMemory(&tmpOfn, sizeof(tmpOfn));
	tmpOfn.lStructSize = sizeof(tmpOfn);
	tmpOfn.hwndOwner = hwnd;
	tmpOfn.lpstrFile = fileBuff;
	tmpOfn.lpstrFile[0] = '\0';
	tmpOfn.nMaxFile = sizeof(fileBuff);
	tmpOfn.lpstrFilter = "All\0*.*\0Text\0*.TXT\0";
	tmpOfn.nFilterIndex = 1;
	tmpOfn.lpstrFileTitle = NULL;
	tmpOfn.nMaxFileTitle = 0;
	tmpOfn.lpstrInitialDir = NULL;
	tmpOfn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	printf("\nOpen File Dialog Function Called\n");

	if ( GetOpenFileName(&tmpOfn) == TRUE )
	{
		hwnd = CreateFile(tmpOfn.lpstrFile,
		GENERIC_WRITE,
		0,
		(LPSECURITY_ATTRIBUTES) NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		(HANDLE) NULL);
		printf("\nOpen File Returned True\n");
		return hwnd;
	}
	else
	{
		printf("\nOpen File Returned False\n");
		return NULL;
	}


}

HANDLE saveFileDialog(HANDLE hd)
{
	OPENFILENAME tmpOfn;
	HANDLE hwnd = NULL;
	char fileBuff[260];	// buffer for file name

	ZeroMemory(&tmpOfn, sizeof(tmpOfn));
	tmpOfn.lStructSize = sizeof(tmpOfn);
	tmpOfn.hwndOwner = hwnd;
	tmpOfn.lpstrFile = fileBuff;
	tmpOfn.lpstrFile[0] = '\0';
	tmpOfn.nMaxFile = sizeof(fileBuff);
	tmpOfn.lpstrFilter = "All\0*.*\0Text\0*.TXT\0";
	tmpOfn.nFilterIndex = 1;
	tmpOfn.lpstrFileTitle = NULL;
	tmpOfn.nMaxFileTitle = 0;
	tmpOfn.lpstrInitialDir = NULL;
	tmpOfn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	printf("\nOpen File Dialog Function Called\n");

	if ( GetSaveFileName(&tmpOfn) == TRUE )
	{
		hwnd = CreateFile(tmpOfn.lpstrFile,
		GENERIC_WRITE,
		0,
		(LPSECURITY_ATTRIBUTES) NULL,
		CREATE_NEW,
		FILE_ATTRIBUTE_NORMAL,
		(HANDLE) NULL);
		printf("\nSave Returned True\n");
		return hwnd;
	}
	else
	{
		printf("\nSave Returned False\n");
		return NULL;
	}


}



int main(void)
{
//FILE *fp;


OPENFILENAME ofn;	// common dialog box structure

int t;
int size;

HANDLE hf;			// file handle
HANDLE hfTwo;
HANDLE hwnd;

HINSTANCE hInstance;

DWORD dwBytesToWrite;
DWORD dwBytesWritten;
DWORD len;


BOOL bErrorFlag;

SECURITY_ATTRIBUTES sa;

char pBuf[256];
char szFile[260];	// buffer for file name
char *str = "Hello World\n";
char *strB = "/root/readWrite/newDir";
char *dirC = "C:\\test2";
char *writeBuf = "Goodbye Cruel World";

sa.nLength = sizeof(SECURITY_ATTRIBUTES);
sa.lpSecurityDescriptor = NULL;
sa.bInheritHandle = FALSE;


hInstance = GetModuleHandle(NULL);
dwBytesToWrite = (DWORD)strlen(writeBuf);
dwBytesWritten = 0;
bErrorFlag = FALSE;
hwnd = NULL;
hfTwo = NULL;
len = 256;
t = 0;


//HANDLE hwnd = NULL;		// owner window
//LPDWORD numBytesWritten = NULL;
//LPOVERLAPPED lpOverlapped = NULL;

//HERE

hwnd = openFileDialog(hwnd);

hfTwo = saveFileDialog(hfTwo);

bErrorFlag = WriteFile(hwnd, writeBuf, dwBytesToWrite, &dwBytesWritten, NULL);
// Or
bErrorFlag = WriteFile(hfTwo, writeBuf, dwBytesToWrite, &dwBytesWritten, NULL);

//End

//bErrorFlag = CreateDirectory((LPCSTR)dirC, NULL);


//bErrorFlag = RemoveDirectory((LPCSTR)dirC);

//RemoveDirectory(

/*
if( bErrorFlag == TRUE )
{
	printf("TRUE");
}
else
{
	printf("FALSE");
}
*/

//getcwd(pBuf, len);

size = GetModuleFileName(hInstance, pBuf, len);

/*
//Open File Dialog
ZeroMemory(&ofn, sizeof(ofn));
ofn.lStructSize = sizeof(ofn); // SEE NOTE BELOW
ofn.hwndOwner = hwnd;
ofn.lpstrFile = szFile;
// Set lpstrFile[0] to '\0' so that GetOpenFileName does not
// use the contents of szFile to initialize itself.
ofn.lpstrFile[0] = '\0';
//ofn.lpstrFile = "test.txt";
ofn.nMaxFile = sizeof(szFile);
ofn.lpstrFilter = "All\0*.*\0Text\0*.TXT\0";
ofn.nFilterIndex = 1;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

// Display the Open dialog box

//CreateDirectory(lpPathName, &sad);
bErrorFlag = CreateDirectory((LPCSTR)dirC, NULL);

hfTwo = CreateFile(ofn.lpstrFile,
				  GENERIC_WRITE,
				  0,
				  (LPSECURITY_ATTRIBUTES) NULL,
				  CREATE_ALWAYS,
				  FILE_ATTRIBUTE_NORMAL,
				  (HANDLE) NULL);
 

if ( GetOpenFileName(&ofn) == TRUE )
{
  hf = CreateFile(ofn.lpstrFile,
				  GENERIC_WRITE,
				  0,
				  (LPSECURITY_ATTRIBUTES) NULL,
				  OPEN_EXISTING,
				  FILE_ATTRIBUTE_NORMAL,
				  (HANDLE) NULL);

  bErrorFlag = WriteFile(hf, writeBuf, dwBytesToWrite, &dwBytesWritten, NULL);

  if ( FALSE == bErrorFlag )
  {
	printf("Unable to write file");
  }
  else
  {
	printf("File Written");
  }

  DeleteFile(dirC);

}

*/
/*
for(t = 0; t < size; t++)
{
 printf("%c", pBuf[t]);
}
*/

/*

fp=fopen("morpheus.txt", "w+"); 

if ( fp == NULL )
{
  perror("Failed to open/create file");
  return -1;
}

count = fwrite( str, 1, strlen(str), fp );
printf("Wrote %d bytes.\n", count);

rewind(fp);


while( (i = fgetc(fp)) != EOF)
{
	printf("%c", i);
}



//mkdir(strB, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);

if ( i == 0 )
	printf("Failed Reading\n");
else
	printf("Success Reading\n");

*/

return 0;

}

//BOOL createNewDirectory(char *dir)
//{
//   bErrorFlag = CreateDirectory((LPCSTR)dir, NULL);
//	return CreateDirectory((LPCSTR)dir, NULL);
//}









